def enclose_init_by_debug(class_):
    def _debug(func):
        def wrap(*args, **kwargs):
            print(f'DEBUG: {func.__name__} started')
            ret = func(*args, **kwargs)
            print(f'DEBUG: {func.__name__} ended')
            return ret
        return wrap
    setattr(class_, '__init__',
            _debug(getattr(class_, '__init__')))
    return class_

class Point:
    def __init__(self, x, y):
        self.x, self.y = x, y

    def __str__(self):
        return f'({self.x}, {self.y})'

p = enclose_init_by_debug(Point)(1, 2)
print(p)
